local M = {}

local i = 0
local s = 0
local flightMode=0;
local smokeNodes = {}
local gyroToggle = 0
local afterburner = 1;
local afterburnerStartTime = 0;
local afterburnerStartTimeRemainingtime=0;
local jetExtensionLoaded = 0;


local function onInit()
	flightMode=0;
	gyroToggle = 0;
	electrics.values.flightMode = 0;
	electrics.values.gyro = 1;
	afterburner = 1;
	jetExtensionLoaded = 0
	
	 smokeNodes = {}
	 for k, node in pairs (v.data.nodes) do
		if node.name == "tr" then smokeNodes[1] = k ; jetExtensionLoaded = 1; end
		if node.name == "tr0" then smokeNodes[2] = k   end
		
		if node.name == "tr3" then smokeNodes[3] = k  end
		if node.name == "tr4" then smokeNodes[4] = k   end

		if node.name == "tr5" then smokeNodes[5] = k  end
		if node.name == "tr6" then smokeNodes[6] = k   end

		if node.name == "tr1" then smokeNodes[7] = k  end
		if node.name == "tr2" then smokeNodes[8] = k   end
		
	 end	
end


function getRequiredAngle(input, maxAngle)
   input = input - 0.5;
   inputProcent = input/0.5;
   requiredAngle = inputProcent * maxAngle; 
   return requiredAngle;
end

function gyro(currentValue, reactionFactor, requiredValue, trim)

   diff = (currentValue-requiredValue);
   output = ((diff * diff) +trim) / reactionFactor ;
   output = output;
   if diff > 0 then output  = 0.5 - output else output  = 0.5 + output  end
   if output > 1.0 then output  = 1.0 end
   if output < 0.0 then output  = 0.0 end

   return output; 
end


function gyroToStr(gyro)
	if gyro ~= 0 then
		return "On"
	end
	return "Off"
end

local function updateGFX(dt)
    i = i + 1;
	s = s + 1;
	electrics.values.power = electrics.values.rpm / 5000
	power = electrics.values.power * afterburner;

	if jetExtensionLoaded ~= 0 then
	
	
		if flightMode ~= (electrics.values.flightMode or flightMode) then
			flightMode = electrics.values.flightMode;
			gui.message(string.format('Flight mode is %s',gyroToStr(flightMode)), 2, "flightmode")
		end
		if gyroToggle ~= (electrics.values.gyro or 0) then
			gyroToggle = (electrics.values.gyro or 0);
			gui.message(string.format('Gyro is %s',gyroToStr(gyroToggle)), 2, "gyro")
		end	

		
		if electrics.values.afterburner == 1 then
			afterburner = 2;
			afterburnerStartTime = os.time();
			gui.message(string.format('Afterburner activated'), 2, "afterburner")
			electrics.values.afterburner = 0;
		end	
		if (afterburnerStartTime  ~= 0) then
			if (os.difftime(os.time(), afterburnerStartTime) >10) then
				afterburner = 1;
				afterburnerStartTime = 0;
				gui.message(string.format('Afterburner deactivated'), 2, "afterburner")
			else
				if(afterburnerStartTimeRemainingtime ~= os.difftime(os.time(), afterburnerStartTime)) then
					afterburnerStartTimeRemainingtime = os.difftime(os.time(), afterburnerStartTime);
					gui.message(string.format('Afterburner %s [s]', tostring(10 - afterburnerStartTimeRemainingtime)), 2, "afterburner")
				end
			
			end
			
		end		
		
		
		if flightMode  ~= 0 then
			--Smoke System
			if s and ( s > 1  )  then
				s = 0;
				  local particleAirspeed      = electrics.values.airspeed
				  local lightSmokeParticleType    = particleAirspeed < 10 and 40 or 41
				  local heavySmokeParticleType    = particleAirspeed < 10 and 42 or 43	
				  
				  if electrics.values.rpm  < 4500  then
					obj:addParticleByNodesRelative(smokeNodes[2], smokeNodes[1], electrics.values.rpm * -0.0004 - 3, lightSmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[4], smokeNodes[3], electrics.values.rpm * -0.0004 - 3, lightSmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[6], smokeNodes[5], electrics.values.rpm * -0.0004 - 3, lightSmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[8], smokeNodes[7], electrics.values.rpm * -0.0004 - 3, lightSmokeParticleType, 0, 1)
				  else
					obj:addParticleByNodesRelative(smokeNodes[2], smokeNodes[1], electrics.values.rpm * -0.0004 - 3, heavySmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[4], smokeNodes[3], electrics.values.rpm * -0.0004 - 3, heavySmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[6], smokeNodes[5], electrics.values.rpm * -0.0004 - 3, heavySmokeParticleType, 0, 1)
					obj:addParticleByNodesRelative(smokeNodes[8], smokeNodes[7], electrics.values.rpm * -0.0004 - 3, heavySmokeParticleType, 0, 1)

					end			  
				
			end
		
		
			movexInput = ((electrics.values.steering / 457.40606) / 2)+0.5
			
			local dirVector = obj:getDirectionVector()
			local dirVectorUp = obj:getDirectionVectorUp()	
			electrics.values.rollDeg = (dirVectorUp.x * -dirVector.y + dirVectorUp.y * dirVector.x) * 90;
			electrics.values.pitchDeg = -(dirVector.z * 90);
			
			moveSide = 0.0
			moveForward = 0.0
			forwardTrim = 0.05

			if gyroToggle ~= 0 then
				-- Roll Gyro
				requiredRollAngle = getRequiredAngle((movexInput or 0.5), 30);
				movex = gyro((electrics.values.rollDeg or 0), 6000, requiredRollAngle, 0);
				moveSide = -(math.floor(movex *100)/10-5)/10;
				
				-- Pitch Gyro
				requiredPitchAngle = getRequiredAngle((electrics.values.moveForward or 0.5), 40);
				movey = gyro((electrics.values.pitchDeg or 0), 9000, requiredPitchAngle, 0);
				moveForward = (math.floor(movey *100)/10-5)/10;
			else
			moveSide = -((movexInput or 0.5)-0.5);
			moveForward = (electrics.values.moveForward or 0.5) - 0.5;
			end

			moveForward = moveForward + forwardTrim
			electrics.values.turbine_FL = (power or 0) + (moveSide or 0) - (moveForward or 0) 
			electrics.values.turbine_FR = (power or 0) - (moveSide or 0) - (moveForward or 0)	
			electrics.values.turbine_RL = (power or 0) + (moveSide or 0) + (moveForward or 0)
			electrics.values.turbine_RR = (power or 0) - (moveSide or 0) + (moveForward or 0)	
			
			if(movexInput >= 0.51) then
				electrics.values.turbine_vl = -(0.5 - (movexInput or 0))
			end
			if(movexInput <= 0.49) then
				electrics.values.turbine_vr = (0.5 - (movexInput or 0))
			end
			
			electrics.values.wheelspeed = electrics.values.airspeed	
		else 
			electrics.values.turbine_FL = 0
			electrics.values.turbine_FR = 0
			electrics.values.turbine_RL = 0
			electrics.values.turbine_RR = 0
		end
	else
		if flightMode ~= (electrics.values.flightMode or flightMode) then
			flightMode = electrics.values.flightMode;
			gui.message('You Need Jet Turbines', 2, "flightmode")
		end	
		
	end
		
    if i and ( i > 10 )  then
	
        --gui.message(string.format('power:%s, altitude: %s, requiredautoPilot:%s',tostring(power), tostring(electrics.values.altitude), tostring(requiredautoPilot)))
        -- gui.message(string.format('rollDeg:%s, pitchDeg:%s',tostring(electrics.values.rollDeg),tostring(electrics.values.pitchDeg)
        --gui.message(string.format('electrics.values.turbine_vr: %s',tostring(electrics.values.turbine_vr or 0)), 2, "gearshift")
		i = 0
    end
	--electrics.values.wheelspeed = electrics.values.airspeed	
end

M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX


return M